namespace USPS
{
	using System;
	using System.Data;
	using System.Configuration;
	using System.Web;
	using System.Web.Security;
	using System.Web.UI;
	using System.Web.UI.WebControls;
	using System.Web.UI.WebControls.WebParts;
	using System.Web.UI.HtmlControls;
	using System.Net;
	using System.IO;
	using System.Text;
	using System.Xml;

	/// <summary>
	/// Summary description for USPSTrack
	/// </summary>
	public class USPSTrack
	{
		public string trackingNumer;
		private string apiModule;
		private string userId;
		private string password;
		private string url;

		public USPSTrack()
		{
			trackingNumer = string.Empty;
			apiModule = string.Empty;
			userId = string.Empty;
			password = string.Empty;
			url = string.Empty;
		}

		public string RequestUSPSTrackingInfo()
		{
			try
			{
				InitiateService();
				string _xmlRequestString = BuildXMLRequest();
				string _xmlResponseString;

				Uri USPSUri = new Uri(url + "API=" + apiModule + "&XML=" + _xmlRequestString);
				// Create a new request to the above mentioned URL.    
				WebRequest myWebRequest = WebRequest.Create(USPSUri);
				// Assign the response object of 'WebRequest' to a 'WebResponse' variable.
				WebResponse myWebResponse = myWebRequest.GetResponse();

				StreamReader sr = new StreamReader(myWebResponse.GetResponseStream());
				_xmlResponseString = sr.ReadToEnd();
				return _xmlResponseString;
			}
			catch
			{
				return "E";
			}
		}

		//Initialize service parameters
		private void InitiateService()
		{
			string _serivceMode = ConfigurationManager.AppSettings["ServiceMode"];
			password = ConfigurationManager.AppSettings["USPSPassword"];
			userId = ConfigurationManager.AppSettings["USPSKey"];
			apiModule = "TrackV2";

			if (_serivceMode == "Test")
			{
				url = ConfigurationManager.AppSettings["USPSTestURL"];
			}
			else
			{
				url = ConfigurationManager.AppSettings["USPSProdURL"];
			}
		}

		// Construct the request xml string
		private string BuildXMLRequest()
		{
			StringWriter sw = new StringWriter();
			XmlTextWriter xmlWriter = new XmlTextWriter(sw);
			xmlWriter.WriteStartDocument();
			xmlWriter.WriteStartElement("TrackRequest");
			xmlWriter.WriteAttributeString("USERID", userId);
			xmlWriter.WriteAttributeString("PASSWORD", password);
			xmlWriter.WriteStartElement("TrackID");
			xmlWriter.WriteAttributeString("ID", trackingNumer.ToString());
			xmlWriter.WriteEndElement();
			xmlWriter.WriteEndElement();
			return sw.ToString();
		}
	}
}